//+------------------------------------------------------------------+
//|                                              airforce Slope.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright ?2008, MetaQuotes Software Corp."

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
double Lots = 0.1;
double SlopeV0_1,SlopeV1_1;
double SlopeV0_2,SlopeV1_2;
double CrossUp,CrossDown;
extern int p_period = 40;
extern int p_method = 3;
extern int p_price = 0;
extern int tppoint = 50;
extern int slpoint = 50;
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
        if(Bars<100 || IsTradeAllowed()==false) return;
   
   
   CheckForClose();
   if (OrdersTotal()==0){
     CheckForOpen();
   }

//----
   return(0);
  }
//+------------------------------------------------------------------+
void CheckForClose() {
      SlopeV0_1      = iCustom(NULL,0,"Slope Direction Line",p_period,p_method,p_price,0,1);
      SlopeV1_1      = iCustom(NULL,0,"Slope Direction Line",p_period,p_method,p_price,1,1);
      SlopeV0_2      = iCustom(NULL,0,"Slope Direction Line",p_period,p_method,p_price,0,2);
      SlopeV1_2      = iCustom(NULL,0,"Slope Direction Line",p_period,p_method,p_price,1,2);
//      QQE_S1      = iCustom(NULL,0,"QQEA",QQEp1,QQEp2,4.236,1,1);
//      QQE_S2      = iCustom(NULL,0,"QQEA",QQEp1,QQEp2,4.236,1,2);
   int total=OrdersTotal();
   if(total<=0) {return;}
   for (int i = total-1;i>=0 ;i--){
       if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)!=True) {
                 Print("OrderSelect صĴ ",GetLastError());
       }
       int order_ticket = OrderTicket();
       double order_lots = OrderLots();
       if((OrderType()==OP_SELL)&&(SlopeV0_1==SlopeV1_1)) {
           if (OrderClose(order_ticket,order_lots,Ask,8,NULL)!=True) {
                 Print("OrderClose صĴ ",GetLastError(),"ticket = ",order_ticket,"lots= ",order_lots,"price=",Ask);   
          }   
       } else if ((OrderType()==OP_BUY)&&(SlopeV0_1==SlopeV1_1)){
           if (OrderClose(order_ticket,order_lots,Bid,8,NULL)!=True){
                 Print("OrderClose صĴ ",GetLastError(),"ticket = ",order_ticket,"lots= ",order_lots,"price=",Bid);   
          }  
       }
   } 
  
}
void CheckForOpen(){
 int ticket;
      SlopeV0_1      = iCustom(NULL,0,"Slope Direction Line",p_period,p_method,p_price,0,1);
      SlopeV1_1      = iCustom(NULL,0,"Slope Direction Line",p_period,p_method,p_price,1,1);
      SlopeV0_2      = iCustom(NULL,0,"Slope Direction Line",p_period,p_method,p_price,0,2);
      SlopeV1_2      = iCustom(NULL,0,"Slope Direction Line",p_period,p_method,p_price,1,2);
   if ((SlopeV0_1==SlopeV1_1) &&(SlopeV1_2>0)&&(SlopeV1_2<1000)) {
         Print ("V0_1=" ,SlopeV0_1,"  V0_2=",SlopeV0_2,"  V1_2=",SlopeV1_2);
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"",1,0,Green);
             if ((tppoint>0)&&(slpoint>0)){
                ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-slpoint*Point,Ask+tppoint*Point,"",2,0,Green);
             } else if (tppoint>0) {
                ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+tppoint*Point,"",2,0,Green);
             } else if (slpoint>0) {
                ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-slpoint*Point,0,"",2,0,Green);
             }
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 

  } else if ((SlopeV0_1==SlopeV1_1) &&(SlopeV0_2>0)&&(SlopeV0_2<1000)){
         Print ("V0_1=" ,SlopeV0_1,"  V0_2=",SlopeV0_2,"  V1_2=",SlopeV1_2);
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"",1,0,Red);
             if ((tppoint>0)&&(slpoint>0)){
                 ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+slpoint*Point,Bid-tppoint*Point,"",2,0,Red);
             } else if (tppoint>0)    {
                 ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-tppoint*Point,"",2,0,Red);
             }    else if (slpoint>0)    {
                 ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+slpoint*Point,0,"",2,0,Red);
             }    

         
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("Sell order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 

  }
}

